<?php

namespace App\Domain\Customers\Tests\Factories;

use Ensi\CustomerAuthClient\Dto\ConfirmationCodeModel;
use Ensi\CustomerAuthClient\Dto\SearchConfirmationCodesResponse;
use Ensi\LaravelTestFactories\BaseApiFactory;

class CustomerConfirmationCodeFactory extends BaseApiFactory
{
    protected function definition(): array
    {
        return [
            'id' => $this->faker->modelId(),
            'user_id' => $this->faker->numberBetween(1),
            'phone' => $this->faker->numerify('+7##########'),
            'attempt' => $this->faker->numberBetween(1),
            'failed_checks_count' => $this->faker->numberBetween(0, 3),
            'expired_at' => $this->faker->dateTime(),
            'verified_at' => $this->faker->nullable()->dateTime(),
            'created_at' => $this->faker->dateTime(),
        ];
    }

    public function make(array $extra = []): ConfirmationCodeModel
    {
        return new ConfirmationCodeModel($this->makeArray($extra));
    }

    public function makeResponseSearch(array $extras = [], int $count = 1, mixed $pagination = null): SearchConfirmationCodesResponse
    {
        return $this->generateResponseSearch(SearchConfirmationCodesResponse::class, $extras, $count, $pagination);
    }
}
