<?php

namespace App\Domain\Customers\Tests\Factories;

use Ensi\CustomersClient\Dto\DeletingCustomer;
use Ensi\CustomersClient\Dto\SearchDeletingCustomersResponse;
use Ensi\LaravelTestFactories\BaseApiFactory;

class DeletingCustomersFactory extends BaseApiFactory
{
    protected function definition(): array
    {
        return [
            'id' => $this->faker->modelId(),
            'customer_id' => $this->faker->modelId(),
            'created_at' => $this->faker->dateTime(),
            'updated_at' => $this->faker->dateTime(),
        ];
    }

    public function make(array $extra = []): DeletingCustomer
    {
        return new DeletingCustomer($this->makeArray($extra));
    }

    public function makeResponseSearch(array $extras = [], int $count = 1, mixed $pagination = null): SearchDeletingCustomersResponse
    {
        return $this->generateResponseSearch(SearchDeletingCustomersResponse::class, $extras, $count, $pagination);
    }
}
