<?php

namespace App\Domain\Orders\Tests\Factories\Refunds;

use Ensi\LaravelTestFactories\BaseApiFactory;
use Ensi\OmsClient\Dto\RefundReason;
use Ensi\OmsClient\Dto\RefundReasonResponse;
use Ensi\OmsClient\Dto\RefundReasonsResponse;

class RefundReasonFactory extends BaseApiFactory
{
    protected function definition(): array
    {
        return [
            'id' => $this->faker->modelId(),
            'code' => $this->faker->text(10),
            'name' => $this->faker->text(10),
            'description' => $this->faker->nullable()->text(50),
            'created_at' => $this->faker->dateTime(),
            'updated_at' => $this->faker->dateTime(),
        ];
    }

    public function make(array $extra = []): RefundReason
    {
        return new RefundReason($this->makeArray($extra));
    }

    public function makeResponse(array $extra = []): RefundReasonResponse
    {
        return new RefundReasonResponse(['data' => $this->make($extra)]);
    }

    public function makeResponseMany(array $extra = []): RefundReasonsResponse
    {
        return new RefundReasonsResponse(['data' => [$this->make($extra)],]);
    }
}
