<?php

namespace App\Http\ApiV1\Modules\Catalog\Controllers\Feeds;

use App\Domain\Common\Data\Meta\Field;
use App\Http\ApiV1\Modules\Catalog\Queries\Feeds\ActualCategoryPropertiesQuery;
use App\Http\ApiV1\Modules\Catalog\Resources\Feeds\ActualCategoryPropertiesResource;
use App\Http\ApiV1\Support\Resources\ModelMetaResource;
use Illuminate\Contracts\Support\Responsable;

class ActualCategoryPropertiesController
{
    public function search(ActualCategoryPropertiesQuery $query): Responsable
    {
        return ActualCategoryPropertiesResource::collectPage($query->get());
    }

    public function meta(): Responsable
    {
        return new ModelMetaResource([
            Field::id()->listDefault()->filterDefault()->sortDefault(direction: 'desc'),
            Field::integer('actual_category_property_id', __('meta.actual_category_properties.actual_category_property_id'))->filter()->filterDefault()->listDefault()->resetSort(),

            Field::integer('property_id', __('meta.actual_category_properties.property_id'))->filter()->filterDefault()->listDefault()->resetSort(),
            Field::integer('category_id', __('meta.actual_category_properties.category_id'))->filter()->filterDefault()->listDefault()->resetSort(),

            Field::boolean('is_migrated', __('meta.is_migrated'))->filterDefault()->listDefault(),

            Field::datetime('created_at', __('meta.created_at'))->filterDefault()->listDefault(),
            Field::datetime('updated_at', __('meta.updated_at'))->filterDefault()->listDefault(),
        ]);
    }
}
