<?php

namespace App\Http\ApiV1\Modules\Catalog\Queries\Feeds;

use App\Http\ApiV1\Modules\Catalog\Queries\FeedQuery;
use Ensi\FeedClient\Api\ActualCategoryPropertiesApi;
use Ensi\FeedClient\Dto\SearchActualCategoryPropertiesRequest;
use Ensi\FeedClient\Dto\SearchActualCategoryPropertiesResponse;
use Illuminate\Http\Request;
use LogicException;

class ActualCategoryPropertiesQuery extends FeedQuery
{
    public function __construct(Request $request, private ActualCategoryPropertiesApi $api)
    {
        parent::__construct($request, SearchActualCategoryPropertiesRequest::class);
    }

    protected function searchById($id, string $include)
    {
        throw new LogicException('Not supported');
    }

    protected function search($request): SearchActualCategoryPropertiesResponse
    {
        return $this->api->searchActualCategoryProperties($request);
    }
}
