<?php

namespace App\Http\ApiV1\Modules\Customers\Controllers;

use App\Domain\Common\Data\Meta\Enum\Customers\CustomerUserEnumInfo;
use App\Domain\Common\Data\Meta\Field;
use App\Http\ApiV1\Modules\Customers\Queries\DeletingCustomersQuery;
use App\Http\ApiV1\Modules\Customers\Resources\DeletingCustomersResource;
use App\Http\ApiV1\Support\Pagination\PageBuilderFactory;
use App\Http\ApiV1\Support\Resources\ModelMetaResource;
use Illuminate\Contracts\Support\Responsable;

class DeletingCustomersController
{
    public function search(PageBuilderFactory $pageBuilderFactory, DeletingCustomersQuery $query): Responsable
    {
        return DeletingCustomersResource::collectPage($query->get());
    }

    public function meta(
        CustomerUserEnumInfo $customerUserEnumInfo,
    ): ModelMetaResource {
        return new ModelMetaResource([
            Field::id()->listDefault()->filterDefault(),
            Field::enum('customer_id', __('meta.deleting_customers.customer_id'), $customerUserEnumInfo)->listDefault()->filterDefault(),

            Field::datetime('created_at', __('meta.created_at'))->listDefault(),
            Field::datetime('updated_at', __('meta.updated_at'))->listDefault(),
        ]);
    }
}
