<?php

namespace App\Http\ApiV1\Modules\Customers\Queries;

use Ensi\CustomerAuthClient\Api\ConfirmationCodesApi;
use Ensi\CustomerAuthClient\Dto\SearchConfirmationCodesRequest;
use Ensi\CustomerAuthClient\Dto\SearchConfirmationCodesResponse;
use Illuminate\Http\Request;

class CustomersConfirmationCodesQuery extends AbstractCustomerAuthQuery
{
    public function __construct(
        protected Request $httpRequest,
        protected readonly ConfirmationCodesApi $confirmationCodesApi,
    ) {
        parent::__construct($httpRequest, SearchConfirmationCodesRequest::class);
    }

    protected function search($request): SearchConfirmationCodesResponse
    {
        return $this->confirmationCodesApi->searchConfirmationCodes($request);
    }
}
