<?php

namespace App\Http\ApiV1\Modules\Customers\Queries;

use Ensi\CustomersClient\Api\DeletingCustomersApi;
use Ensi\CustomersClient\Dto\SearchDeletingCustomersRequest;
use Ensi\CustomersClient\Dto\SearchDeletingCustomersResponse;
use Illuminate\Http\Request;

class DeletingCustomersQuery extends AbstractCustomersQuery
{
    public function __construct(
        protected Request $httpRequest,
        protected readonly DeletingCustomersApi $deletingCustomersApi
    ) {
        parent::__construct($httpRequest, SearchDeletingCustomersRequest::class);
    }

    protected function search($request): SearchDeletingCustomersResponse
    {
        return $this->deletingCustomersApi->searchDeletingCustomers($request);
    }
}
