<?php

namespace App\Http\ApiV1\Modules\Customers\Resources;

use App\Http\ApiV1\Support\Resources\BaseJsonResource;
use Ensi\CustomerAuthClient\Dto\ConfirmationCodeModel;

/** @mixin ConfirmationCodeModel */
class CustomerConfirmationCodesResource extends BaseJsonResource
{
    public function toArray($request): array
    {
        return [
            'id' => $this->getId(),
            'user_id' => $this->getUserId(),
            'phone' => $this->getPhone(),
            'attempt' => $this->getAttempt(),
            'failed_checks_count' => $this->getFailedChecksCount(),
            'expired_at' => $this->dateTimeToIso($this->getExpiredAt()),
            'verified_at' => $this->dateTimeToIso($this->getVerifiedAt()),
            'created_at' => $this->dateTimeToIso($this->getCreatedAt()),
        ];
    }
}
