<?php

namespace App\Http\ApiV1\Modules\Logistic\Policies\DeliveryServices;

use App\Domain\Auth\Models\User;
use Ensi\AdminAuthClient\Dto\RightsAccessEnum;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Auth\Access\Response;

class DeliveryServicePaymentMethodLinksControllerPolicy
{
    use HandlesAuthorization;

    public function add(User $user): Response
    {
        return $user->allowOneOf([
            RightsAccessEnum::DELIVERY_SERVICES_PAYMENT_METHOD_EDIT,
        ]);
    }

    public function delete(User $user): Response
    {
        return $user->allowOneOf([
            RightsAccessEnum::DELIVERY_SERVICES_PAYMENT_METHOD_EDIT,
        ]);
    }
}
