<?php

namespace App\Http\ApiV1\Modules\Logistic\Requests\DeliveryServices;

use App\Http\ApiV1\OpenApiGenerated\Enums\OrdersPaymentMethodEnum;
use App\Http\ApiV1\Support\Requests\BaseFormRequest;
use Illuminate\Validation\Rules\Enum;

class AddPaymentMethodsToDeliveryServiceRequest extends BaseFormRequest
{
    public function rules(): array
    {
        return [
            'payment_methods' => ['required', 'array', 'min:1'],
            'payment_methods.*' => ['required', new Enum(OrdersPaymentMethodEnum::class)],
        ];
    }

    public function getPaymentMethods(): array
    {
        return $this->get('payment_methods');
    }
}
