<?php

/**
 * NOTE: This file is auto generated by OpenAPI Generator.
 * Do NOT edit it manually. Run `php artisan openapi:generate-server`.
 */

namespace App\Http\ApiV1\OpenApiGenerated\Enums;

/**
 * Доступные виды переменных в уведомлениях:
 * * `{order_products}` - список продуктов в заказе
 * * `{delivery_products}` - список продуктов в отправлении
 * * `{product_name}` - название товара (связано с order_products или delivery_products)
 * * `{product_qty}` - количество товара в позиции (связано с order_products или delivery_products)
 * * `{product_price}` - цена позиции с товаром со скидкой (связано с order_products или delivery_products)
 * * `{product_cost}` - цена позиции с товаром без скидки (связано с order_products или delivery_products)
 * * `{product_image}` - ссылка главного изображения товара (связано с order_products или delivery_products)
 * * `{order_receiver_name}` - имя получателя
 * * `{order_receiver_phone}` - телефон получателя
 * * `{order_number}` - номер заказа
 * * `{order_payment_link}` - ссылка на оплату
 * * `{order_price}` - итоговая стоимость заказа
 * * `{order_products_price}` - стоимость товаров в заказе
 * * `{order_delivery_price}` - стоимость доставки
 * * `{order_delivery_method}` - метод доставки
 * * `{order_delivery_address}` - адрес доставки
 * * `{order_delivery_point}` - точка самовывоза
 * * `{order_delivery_comment}` - комментарий к доставке
 * * `{order_deliveries}` - отправления в заказе
 * * `{order_delivery_number}` - номер отправления (связано с order_deliveries, если событие связано с заказом)
 * * `{order_delivery_date}` - дата доставки отправления (связано с order_deliveries, если событие связано с заказом)
 * * `{order_delivery_timeslot}` - временной диапазон доставки отправления (связано с order_deliveries, если событие связано с заказом)
 * * `{customer_name}` - имя клиента
 * * `{confirmation_code}` - код подтверждения
 */
enum CommunicationVariableEnum: string
{
    /** Cписок продуктов в заказе */
    case ORDER_PRODUCTS = '{order_products}';
    /** Cписок продуктов в отправлении */
    case DELIVERY_PRODUCTS = '{delivery_products}';
    /** Название товара */
    case PRODUCT_NAME = '{product_name}';
    /** Количество товара в позиции */
    case PRODUCT_QTY = '{product_qty}';
    /** Цена позиции с товаром со скидкой */
    case PRODUCT_PRICE = '{product_price}';
    /** Цена позиции с товаром без скидки */
    case PRODUCT_COST = '{product_cost}';
    /** Ссылка главного изображения товара */
    case PRODUCT_IMAGE = '{product_image}';
    /** Имя получателя */
    case ORDER_RECEIVER_NAME = '{order_receiver_name}';
    /** Телефон получателя */
    case ORDER_RECEIVER_PHONE = '{order_receiver_phone}';
    /** Номер заказа */
    case ORDER_NUMBER = '{order_number}';
    /** Ссылка на оплату */
    case ORDER_PAYMENT_LINK = '{order_payment_link}';
    /** Итоговая стоимость заказа */
    case ORDER_PRICE = '{order_price}';
    /** Стоимость товаров в заказе */
    case ORDER_PRODUCTS_PRICE = '{order_products_price}';
    /** Стоимость доставки */
    case ORDER_DELIVERY_PRICE = '{order_delivery_price}';
    /** Метод доставки */
    case ORDER_DELIVERY_METHOD = '{order_delivery_method}';
    /** Адрес доставки */
    case ORDER_DELIVERY_ADDRESS = '{order_delivery_address}';
    /** Точка самовывоза */
    case ORDER_DELIVERY_POINT = '{order_delivery_point}';
    /** Комментарий к доставке */
    case ORDER_DELIVERY_COMMENT = '{order_delivery_comment}';
    /** Отправления в заказе */
    case ORDER_DELIVERIES = '{order_deliveries}';
    /** Номер отправления */
    case ORDER_DELIVERY_NUMBER = '{order_delivery_number}';
    /** Дата доставки отправления */
    case ORDER_DELIVERY_DATE = '{order_delivery_date}';
    /** Временной диапазон доставки отправления */
    case ORDER_DELIVERY_TIMESLOT = '{order_delivery_timeslot}';
    /** Имя клиента */
    case CUSTOMER_NAME = '{customer_name}';
    /** Код подтверждения */
    case CONFIRMATION_CODE = '{confirmation_code}';
}
